diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/core/model/trickle-timer.cc ns-3.34/src/core/model/trickle-timer.cc
--- ns-3.33/src/core/model/trickle-timer.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/core/model/trickle-timer.cc	2021-07-14 10:31:06.000000000 -0700
@@ -0,0 +1,274 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' di Firenze, Italy
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ */
+
+#include "trickle-timer.h"
+#include "log.h"
+#include <limits>
+
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("TrickleTimer");
+
+TrickleTimer::TrickleTimer ()
+  : m_impl (0),
+    m_timerExpiration (),
+    m_intervalExpiration (),
+    m_currentInterval (Time(0)),
+    m_counter (0),
+    m_uniRand (CreateObject<UniformRandomVariable> ())
+{
+  NS_LOG_FUNCTION (this);
+
+  m_minInterval = Time (0);
+  m_ticks = 0;
+  m_maxInterval = Time (0);
+  m_redundancy = 0;
+}
+
+TrickleTimer::TrickleTimer (Time minInterval, uint8_t doublings, uint16_t redundancy)
+  : m_impl (0),
+    m_timerExpiration (),
+    m_intervalExpiration (),
+    m_currentInterval (Time(0)),
+    m_counter (0),
+    m_uniRand (CreateObject<UniformRandomVariable> ())
+{
+  NS_LOG_FUNCTION (this << minInterval << doublings << redundancy);
+  NS_ASSERT_MSG (doublings < std::numeric_limits<decltype(m_ticks)>::digits, "Doublings value is too large");
+
+  m_minInterval = minInterval;
+  m_ticks = 1;
+  m_ticks <<= doublings;
+  m_maxInterval = m_ticks * minInterval;
+  m_redundancy = redundancy;
+}
+
+TrickleTimer::~TrickleTimer ()
+{
+  NS_LOG_FUNCTION (this);
+  m_timerExpiration.Cancel ();
+  m_intervalExpiration.Cancel ();
+  delete m_impl;
+}
+
+int64_t
+TrickleTimer::AssignStreams (int64_t streamNum)
+{
+  m_uniRand->SetStream (streamNum);
+  return 1;
+}
+
+void
+TrickleTimer::SetParameters (Time minInterval, uint8_t doublings, uint16_t redundancy)
+{
+  NS_LOG_FUNCTION (this << minInterval << doublings << redundancy);
+  NS_ASSERT_MSG (doublings < std::numeric_limits<decltype(m_ticks)>::digits, "Doublings value is too large");
+
+  m_minInterval = minInterval;
+  m_ticks = 1;
+  m_ticks <<= doublings;
+  m_maxInterval = m_ticks * minInterval;
+  m_redundancy = redundancy;
+}
+
+Time
+TrickleTimer::GetMinInterval (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return m_minInterval;
+}
+
+Time
+TrickleTimer::GetMaxInterval (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return m_maxInterval;
+}
+
+uint8_t
+TrickleTimer::GetDoublings (void) const
+{
+  NS_LOG_FUNCTION (this);
+
+  if (m_ticks == 0)
+    {
+      return 0;
+    }
+
+  // Here we assume that m_ticks is a power of 2.
+  // This could have been way more elegant by using
+  // std::countl_zero() defined in the <bit> header
+  // which is c++20 - so not yet widely available.
+
+  uint64_t ticks = m_ticks;
+  uint8_t doublings = 0;
+  while (ticks != 1)
+    {
+      ticks >>= 1;
+      doublings ++;
+    }
+
+  return doublings;
+}
+
+uint16_t
+TrickleTimer::GetRedundancy (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return m_redundancy;
+}
+
+Time
+TrickleTimer::GetDelayLeft (void) const
+{
+  NS_LOG_FUNCTION (this);
+
+  if (m_timerExpiration.IsRunning ())
+    {
+      return Simulator::GetDelayLeft (m_timerExpiration);
+    }
+
+  return TimeStep (0);
+}
+
+Time
+TrickleTimer::GetIntervalLeft (void) const
+{
+  NS_LOG_FUNCTION (this);
+
+  if (m_intervalExpiration.IsRunning ())
+    {
+      return Simulator::GetDelayLeft (m_intervalExpiration);
+    }
+
+  return TimeStep (0);
+}
+
+
+void
+TrickleTimer::Enable ()
+{
+  NS_LOG_FUNCTION (this);
+
+  uint64_t randomInt;
+  double random;
+
+  NS_ASSERT_MSG (m_minInterval != Time (0), "Timer not initialized");
+
+  randomInt = m_uniRand->GetInteger (1, m_ticks);
+  random = randomInt;
+  if (randomInt < m_ticks)
+    {
+      random += m_uniRand->GetValue (0, 1);
+    }
+
+  m_currentInterval = m_minInterval * random;
+  m_intervalExpiration = Simulator::Schedule (m_currentInterval, &TrickleTimer::IntervalExpire, this);
+
+  m_counter = 0;
+
+  Time timerExpitation = m_uniRand->GetValue (0.5, 1) * m_currentInterval;
+  m_timerExpiration = Simulator::Schedule (timerExpitation, &TrickleTimer::TimerExpire, this);
+
+  return;
+}
+
+void
+TrickleTimer::ConsistentEvent ()
+{
+  NS_LOG_FUNCTION (this);
+  m_counter ++;
+}
+
+void
+TrickleTimer::InconsistentEvent ()
+{
+  NS_LOG_FUNCTION (this);
+  if (m_currentInterval > m_minInterval)
+    {
+      Reset ();
+    }
+}
+
+void
+TrickleTimer::Reset ()
+{
+  NS_LOG_FUNCTION (this);
+
+  m_currentInterval = m_minInterval;
+  m_intervalExpiration.Cancel ();
+  m_timerExpiration.Cancel ();
+
+  m_intervalExpiration = Simulator::Schedule (m_currentInterval, &TrickleTimer::IntervalExpire, this);
+
+  m_counter = 0;
+
+  Time timerExpitation = m_uniRand->GetValue (0.5, 1) * m_currentInterval;
+  m_timerExpiration = Simulator::Schedule (timerExpitation, &TrickleTimer::TimerExpire, this);
+
+  return;
+}
+
+void
+TrickleTimer::Stop ()
+{
+  NS_LOG_FUNCTION (this);
+
+  m_currentInterval = m_minInterval;
+  m_intervalExpiration.Cancel ();
+  m_timerExpiration.Cancel ();
+  m_counter = 0;
+}
+
+void
+TrickleTimer::TimerExpire(void)
+{
+  NS_LOG_FUNCTION (this);
+
+  if (m_counter < m_redundancy || m_redundancy == 0)
+    {
+      m_impl->Invoke ();
+    }
+}
+
+void
+TrickleTimer::IntervalExpire(void)
+{
+  NS_LOG_FUNCTION (this);
+
+  m_currentInterval = m_currentInterval * 2;
+  if (m_currentInterval > m_maxInterval)
+    {
+      m_currentInterval = m_maxInterval;
+    }
+
+  m_intervalExpiration = Simulator::Schedule (m_currentInterval, &TrickleTimer::IntervalExpire, this);
+
+  m_counter = 0;
+
+  Time timerExpitation = m_uniRand->GetValue (0.5, 1) * m_currentInterval;
+  m_timerExpiration = Simulator::Schedule (timerExpitation, &TrickleTimer::TimerExpire, this);
+}
+
+
+
+} // namespace ns3
+
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/core/model/trickle-timer.h ns-3.34/src/core/model/trickle-timer.h
--- ns-3.33/src/core/model/trickle-timer.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/core/model/trickle-timer.h	2021-07-14 10:31:06.000000000 -0700
@@ -0,0 +1,296 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' di Firenze, Italy
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ */
+
+#ifndef TRICKLE_TIMER_H
+#define TRICKLE_TIMER_H
+
+#include "nstime.h"
+#include "event-id.h"
+#include "random-variable-stream.h"
+
+/**
+ * \file
+ * \ingroup timer
+ * ns3::TrickleTimer timer class declaration.
+ */
+
+namespace ns3 {
+
+class TimerImpl;
+
+/**
+ * \ingroup timer
+ * \brief A Trickle Timer following \RFC{6206}.
+ *
+ * A Trickle Timer is a timer that varies its frequency between a minimum
+ * and a maximum, depending on events. It is typically used to exchange
+ * information in a highly robust, energy efficient, simple, and scalable manner.
+ *
+ * The Trickle Timer has three parameters:
+ *   - minInterval Minimum interval.
+ *   - doublings Number of doublings to reach the maximum interval.
+ *   - redundancy Redundancy constant.
+ *
+ * The timer *period* is variable. It starts at minInterval, and it doubles
+ * the period length up to maxInterval = std::exp2 (doublings) * minInterval.
+ *
+ * The period is reset to minInterval when an *inconsistent* event is detected
+ * (see `TrickleTimer::InconsistentEvent`).
+ *
+ * The actual function fired by the timer is *not* called when a period expires.
+ * Rather, it is called in random moment between half of the actual period,
+ * and the end of actual the period.
+ * Moreover, the function is *not* fired if the timer did detect in the actual
+ * period a number of *consistent* events (see `TrickleTimer::ConsistentEvent`)
+ * greater than the redundancy constant. Setting the redundancy constant to zero
+ * disables this feature.
+ *
+ * The Trickle Timer is mainly used to self-regulate the transmission of periodic
+ * information (e.g., Router Advertisements) in wireless networks - and
+ * particularly in LLNs. In these contexts the frequency of the timer is adjusted
+ * according to, e.g., RS multicast messages. Moreover, the redundancy constant
+ * can be used to avoid congestion in high density networks.
+ *
+ * Please refer to \RFC{6206} for a full description and discussion of the Trickle Timer.
+ */
+class TrickleTimer
+{
+public:
+  /** Constructor. */
+  TrickleTimer ();
+
+  /**
+   * Constructor.
+   *
+   * The maximum interval is set to std::exp2 (doublings) * minInterval.
+   *
+   * \param minInterval Minimum interval.
+   * \param doublings Number of doublings to reach the maximum interval.
+   * \param redundancy Redundancy constant.
+   *
+   * A zero value in the redundancy constant means that the suppression
+   * algorithm is disabled.
+   *
+   */
+  TrickleTimer (Time minInterval, uint8_t doublings, uint16_t redundancy);
+
+  /** Destructor. */
+  ~TrickleTimer ();
+
+  /**
+   * Assigns the stream number for the uniform random number generator to use
+   *
+   * \param streamNum first stream index to use
+   * \return the number of stream indices assigned by this helper
+   */
+  int64_t AssignStreams (int64_t streamNum);
+
+  /**
+   * \brief Set the timer parameters.
+   *
+   * The maximum interval is set to std::exp2 (doublings) * minInterval.
+   *
+   * \param minInterval Minimum interval.
+   * \param doublings Number of doublings to reach the maximum interval.
+   * \param redundancy Redundancy constant.
+   *
+   * A zero value in the redundancy constant means that the suppression
+   * algorithm is disabled.
+   *
+   */
+  void SetParameters (Time minInterval, uint8_t doublings, uint16_t redundancy);
+
+  /**
+   * \brief Get the MinInterval of the timer.
+   * \return The MinInterval
+   */
+  Time GetMinInterval (void) const;
+
+  /**
+   * \brief Get the MaxInterval of the timer.
+   *
+   * The timer MaxInterval is always std::exp2 (doublings) * minInterval
+   * \return The MaxInterval
+   */
+  Time GetMaxInterval (void) const;
+
+  /**
+   * \brief Get the doublings of the timer.
+   * \return The doublings
+   */
+  uint8_t GetDoublings (void) const;
+
+  /**
+   * \brief Get the Redundancy constant of the timer.
+   * \return The Redundancy
+   */
+  uint16_t GetRedundancy (void) const;
+
+  /**
+   * \returns The amount of time left until this timer expires.
+   *
+   * This method returns zero if the timer has never been started.
+   */
+  Time GetDelayLeft (void) const;
+
+  /**
+   * \returns The amount of time left until this timer interval expires.
+   *
+   * This method returns zero if the timer has never been started.
+   */
+  Time GetIntervalLeft (void) const;
+
+  /**
+   * \brief Enable the timer.
+   */
+  void Enable ();
+
+  /**
+   * \brief Records a consistent event.
+   */
+  void ConsistentEvent ();
+
+  /**
+   * \brief Records an inconsistent event.
+   */
+  void InconsistentEvent ();
+
+  /**
+   * \brief Reset the timer.
+   */
+  void Reset ();
+
+  /**
+   * \brief Stop the timer.
+   *
+   * This will reset the timer and cancel all the pending events.
+   */
+  void Stop ();
+
+  /**
+   * Set the function to execute when the timer expires.
+   *
+   * \tparam FN \deduced The type of the function.
+   * \param [in] fn The function
+   *
+   * Store this function in this Timer for later use by Timer::Schedule.
+   */
+  template <typename FN>
+  void SetFunction (FN fn);
+
+  /**
+   * Set the function to execute when the timer expires.
+   *
+   * \tparam MEM_PTR \deduced Class method function type.
+   * \tparam OBJ_PTR \deduced Class type containing the function.
+   * \param [in] memPtr The member function pointer
+   * \param [in] objPtr The pointer to object
+   *
+   * Store this function and object in this Timer for later use by Timer::Schedule.
+   */
+  template <typename MEM_PTR, typename OBJ_PTR>
+  void SetFunction (MEM_PTR memPtr, OBJ_PTR objPtr);
+
+
+  /**
+   * Set the arguments to be used when invoking the expire function.
+   */
+  /**@{*/
+  /**
+   * \tparam Ts \deduced Argument types.
+   * \param [in] args arguments
+   */
+  template <typename... Ts>
+  void SetArguments (Ts&&... args);
+  /**@}*/
+
+private:
+  /** Internal callback invoked when the timer expires. */
+  void TimerExpire (void);
+  /** Internal callback invoked when the interval expires. */
+  void IntervalExpire (void);
+
+  /**
+   * The timer implementation, which contains the bound callback
+   * function and arguments.
+   */
+  TimerImpl *m_impl;
+
+  /** The future event scheduled to expire the timer. */
+  EventId m_timerExpiration;
+
+  /** The future event scheduled to expire the interval. */
+  EventId m_intervalExpiration;
+
+
+  Time m_minInterval;    //!< Minimum interval
+  Time m_maxInterval;    //!< Maximum interval
+  uint16_t m_redundancy; //!< Redundancy constant.
+
+  uint64_t m_ticks;       //!< Interval span (i.e., exp2(doublings)).
+  Time m_currentInterval; //!< Current interval.
+  uint16_t m_counter;     //!< Event counter.
+
+  Ptr<UniformRandomVariable> m_uniRand; //!< Object to generate uniform random numbers
+};
+
+} // namespace ns3
+
+
+/********************************************************************
+ *  Implementation of the templates declared above.
+ ********************************************************************/
+
+#include "timer-impl.h"
+
+namespace ns3 {
+
+
+template <typename FN>
+void
+TrickleTimer::SetFunction (FN fn)
+{
+  delete m_impl;
+  m_impl = MakeTimerImpl (fn);
+}
+template <typename MEM_PTR, typename OBJ_PTR>
+void
+TrickleTimer::SetFunction (MEM_PTR memPtr, OBJ_PTR objPtr)
+{
+  delete m_impl;
+  m_impl = MakeTimerImpl (memPtr, objPtr);
+}
+
+template <typename... Ts>
+void
+TrickleTimer::SetArguments (Ts&&... args)
+{
+  if (m_impl == 0)
+    {
+      NS_FATAL_ERROR ("You cannot set the arguments of a TrickleTimer before setting its function.");
+      return;
+    }
+  m_impl->SetArgs (std::forward<Ts>(args)...);
+}
+
+} // namespace ns3
+
+
+#endif /* TRICKLE_TIMER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/core/test/attribute-test-suite.cc ns-3.34/src/core/test/attribute-test-suite.cc
--- ns-3.33/src/core/test/attribute-test-suite.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/core/test/attribute-test-suite.cc	2021-07-14 10:31:06.000000000 -0700
@@ -228,6 +228,12 @@
                      TimeValue (Seconds (-2)),
                      MakeTimeAccessor (&AttributeObjectTest::m_timeWithBounds),
                      MakeTimeChecker (Seconds (-5), Seconds (10)))
+      .AddAttribute ("TestDeprecated", "help text",
+                     BooleanValue (false),
+                     MakeBooleanAccessor (&AttributeObjectTest::m_boolTestDeprecated),
+                     MakeBooleanChecker (),
+                     TypeId::DEPRECATED,
+                     "DEPRECATED test working.")
     ;
 
     return tid;
@@ -320,6 +326,7 @@
 
   bool m_boolTestA;
   bool m_boolTest;
+  bool m_boolTestDeprecated;
   int16_t m_int16;
   int16_t m_int16WithBounds;
   int16_t m_int16SetGet;
@@ -424,6 +431,20 @@
   ok = CheckGetCodePaths (p, "TestBoolName", "true", BooleanValue (true));
   NS_TEST_ASSERT_MSG_EQ (ok, true, "Attribute not set properly by default value");
 
+  std::string expected ("Attribute 'TestDeprecated' is deprecated: DEPRECATED test working.\n");
+  // Temporarily redirect std::cerr to a stringstream
+  std::stringstream buffer;
+  std::streambuf *oldBuffer = std::cerr.rdbuf (buffer.rdbuf());
+  // Cause the deprecation warning to be sent to the stringstream
+  Config::SetDefault ("ns3::AttributeObjectTest::TestDeprecated", BooleanValue (true));
+
+  // Compare the obtained actual string with the expected string.
+  NS_TEST_ASSERT_MSG_EQ (buffer.str (), expected, "Deprecated attribute not working");
+  // Restore cerr to its original stream buffer
+  std::cerr.rdbuf (oldBuffer);
+
+
+
   //
   // Set the default value of the BooleanValue the other way and create an object.
   // The new default value should stick.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/core/test/length-test-suite.cc ns-3.34/src/core/test/length-test-suite.cc
--- ns-3.33/src/core/test/length-test-suite.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/core/test/length-test-suite.cc	2021-07-14 10:31:06.000000000 -0700
@@ -24,7 +24,7 @@
 #include "ns3/string.h"
 #include "ns3/test.h"
 
-#ifdef HAVE_BOOST_UNITS
+#ifdef HAVE_BOOST
 #include <boost/units/base_units/us/foot.hpp>
 #include <boost/units/systems/si.hpp>
 #include <boost/units/systems/si/prefixes.hpp>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/core/test/random-variable-stream-test-suite.cc ns-3.34/src/core/test/random-variable-stream-test-suite.cc
--- ns-3.33/src/core/test/random-variable-stream-test-suite.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/core/test/random-variable-stream-test-suite.cc	2021-07-14 10:31:06.000000000 -0700
@@ -280,30 +280,32 @@
   /**
    * Set the seed used for this test suite.
    *
-   * Over time, this test suite is designed to be run with varying seed
-   * values so that the distributions can be evaluated with chi-squared
-   * tests.  To enable this, normal invocation of this test suite will
-   * result in a seed value corresponding to the seconds since epoch
+   * This test suite is designed to be run with both deterministic and
+   * random seed and run number values.  Deterministic values can be used
+   * for basic regression testing; random values can be used to more
+   * exhaustively test the generated streams, with the side effect of
+   * occasional test failures.
+   * 
+   * By default, this test suite will use the default values of RngSeed = 1
+   * and RngRun = 1.  Users can configure any other seed and run number
+   * in the usual way, but the special value of RngRun = 0 results in
+   * selecting a RngSeed value that corresponds to the seconds since epoch
    * (\c time (0) from \c ctime).  Note: this is not a recommended practice for
    * seeding normal simulations, as described in the ns-3 manual, but
-   * suits our purposes here.
+   * allows the test to be exposed to a wider range of seeds.
    *
-   * However, we also want to provide the ability to run this test suite 
-   * with a repeatable value, such as when the seed or run number is configured
-   * to a specific value.  Therefore, we adopt the following policy.  When
-   * the test program is being run with the default global values for seed
-   * and run number, this function will instead pick a random, time-based
-   * seed for use within this test suite.  If the global values for seed or
-   * run number have been configured differently from the default values,
-   * the global seed value will be used instead of the time-based one.
+   * In either case, the values produced will be checked with a chi-squared
+   * test.
    *
    * For example, this command will cause this test suite to use the
-   * deterministic value of seed=3 every time:
+   * deterministic value of seed=3 and default run number=1 every time:
    *   NS_GLOBAL_VALUE="RngSeed=3" ./test.py -s random-variable-stream-generators
    * or equivalently (to see log output):
    *   NS_LOG="RandomVariableStreamGenerators" NS_GLOBAL_VALUE="RngSeed=3" ./waf --run "test-runner --suite=random-variable-stream-generators"
-   *  Similarly, if the value of RngRun is not set to 1, the globals will be
-   *  used.
+   *
+   * Conversely, this command will cause this test suite to use a seed
+   * based on time-of-day, and run number=0: 
+   *   NS_GLOBAL_VALUE="RngRun=0" ./test.py -s random-variable-stream-generators
    */
   void
   SetTestSuiteSeed (void)
@@ -311,18 +313,18 @@
     if (m_seedSet == false)
       {
         uint32_t seed;
-        if (RngSeedManager::GetSeed () == 1 && RngSeedManager::GetRun () == 1)
+        if (RngSeedManager::GetRun () == 0)
           {
             seed = static_cast<uint32_t> (time (0));
             m_seedSet = true;
-            NS_LOG_DEBUG ("Global seed and run number are default; seeding with time of day: " << seed);
+            NS_LOG_DEBUG ("Special run number value of zero; seeding with time of day: " << seed);
 
           }
         else
           {
             seed = RngSeedManager::GetSeed ();
             m_seedSet = true;
-            NS_LOG_DEBUG ("Global seed and run number are not default; using the non-default values seed: " <<
+            NS_LOG_DEBUG ("Using the values seed: " <<
                           seed << " and run: " << RngSeedManager::GetRun ());
           }
         SeedManager::SetSeed (seed);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/core/test/trickle-timer-test-suite.cc ns-3.34/src/core/test/trickle-timer-test-suite.cc
--- ns-3.33/src/core/test/trickle-timer-test-suite.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/core/test/trickle-timer-test-suite.cc	2021-07-14 10:31:06.000000000 -0700
@@ -0,0 +1,213 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' di Firenze, Italy
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ */
+
+#include "ns3/trickle-timer.h"
+#include "ns3/test.h"
+#include <vector>
+#include <numeric>
+#include <algorithm>
+
+/**
+ * \file
+ * \ingroup core-tests
+ * \ingroup timer
+ * \ingroup timer-tests
+ *
+ * Trickle Timer test suite.
+ *
+ * This test checks that the timer, in steady-state mode (i.e., after
+ * the transient period) have a frequency between [I/2, I + I/2].
+ *
+ * The test also checks that the redundancy works, i.e., if the timer
+ * receives enough "consistent" events it will suppress its output.
+ */
+
+namespace ns3 {
+
+namespace tests {
+
+
+/**
+ * \ingroup timer-tests
+ *  TrickleTimer test
+ */
+class TrickleTimerTestCase : public TestCase
+{
+public:
+  /** Constructor. */
+  TrickleTimerTestCase ();
+  virtual void DoRun (void);
+  /**
+   * Function to invoke when TrickleTimer expires.
+   */
+  void ExpireTimer (void);
+  std::vector<Time> m_expiredTimes;     //!< Time when TrickleTimer expired
+
+  /**
+   * Function to signal that the transient is over
+   */
+  void TransientOver (void);
+
+  /**
+   * Test the steady-state
+   * \param unit Minimum interval
+   */
+  void TestSteadyState (Time unit);
+
+  /**
+   * Test the redundancy suppression
+   * \param unit Minimum interval
+   */
+  void TestRedundancy (Time unit);
+
+  /**
+   * Inject in the timer a consistent event
+   * \param interval Interval
+   * \param tricklePtr Pointer to the TrickleTimer
+   */
+  void ConsistentEvent (Time interval, TrickleTimer* tricklePtr);
+
+  bool m_enableDataCollection;     //!< Collect data if true
+};
+
+TrickleTimerTestCase::TrickleTimerTestCase ()
+  : TestCase ("Check the Trickle Timer algorithm")
+{}
+
+void
+TrickleTimerTestCase::ExpireTimer (void)
+{
+  if (m_enableDataCollection==false)
+    {
+      return;
+    }
+
+  m_expiredTimes.push_back (Simulator::Now ());
+}
+
+void
+TrickleTimerTestCase::TransientOver (void)
+{
+  m_enableDataCollection = true;
+}
+
+void
+TrickleTimerTestCase::TestSteadyState (Time unit)
+{
+  m_expiredTimes.clear ();
+  m_enableDataCollection = false;
+
+  TrickleTimer trickle (unit, 4, 1);
+  trickle.SetFunction (&TrickleTimerTestCase::ExpireTimer, this);
+  trickle.Enable ();
+  // We reset the timer to force the interval to the minimum
+  trickle.Reset ();
+
+  NS_TEST_EXPECT_MSG_EQ (trickle.GetDoublings (), 4, "The doublings re-compute mechanism is not working.");
+
+  // The transient is over at (exp2(doublings +1) -1) * MinInterval (worst case).
+  Simulator::Schedule (unit*31, &TrickleTimerTestCase::TransientOver, this);
+
+  Simulator::Stop (unit * 50000);
+
+  Simulator::Run ();
+  Simulator::Destroy ();
+
+  std::vector<Time> expirationFrequency;
+
+  expirationFrequency.resize (m_expiredTimes.size ());
+  std::adjacent_difference (m_expiredTimes.begin (), m_expiredTimes.end (), expirationFrequency.begin ());
+  expirationFrequency.erase (expirationFrequency.begin ());
+
+  int64x64_t min = (*std::min_element (expirationFrequency.begin (), expirationFrequency.end ()))/unit;
+  int64x64_t max = (*std::max_element (expirationFrequency.begin (), expirationFrequency.end ()))/unit;
+
+  NS_TEST_EXPECT_MSG_GT_OR_EQ (min.GetDouble (), 8, "Timer did fire too fast ??");
+  NS_TEST_EXPECT_MSG_LT_OR_EQ (max.GetDouble (), 24, "Timer did fire too slow ??");
+}
+
+void
+TrickleTimerTestCase::TestRedundancy (Time unit)
+{
+  m_expiredTimes.clear ();
+  m_enableDataCollection = false;
+
+  TrickleTimer trickle (unit, 4, 1);
+  trickle.SetFunction (&TrickleTimerTestCase::ExpireTimer, this);
+  trickle.Enable ();
+  // We reset the timer to force the interval to the minimum
+  trickle.Reset ();
+
+  NS_TEST_EXPECT_MSG_EQ (trickle.GetDoublings (), 4, "The doublings re-compute mechanism is not working.");
+
+  // The transient is over at (exp2(doublings +1) -1) * MinInterval (worst case).
+  Simulator::Schedule (unit*31, &TrickleTimerTestCase::TransientOver, this);
+  Simulator::Schedule (unit*31, &TrickleTimerTestCase::ConsistentEvent, this, unit*8, &trickle);
+
+  Simulator::Stop (unit * 50000);
+
+  Simulator::Run ();
+  Simulator::Destroy ();
+
+  NS_TEST_EXPECT_MSG_EQ (m_expiredTimes.size (), 0, "Timer did fire while being suppressed ??");
+}
+
+void
+TrickleTimerTestCase::ConsistentEvent (Time interval, TrickleTimer* tricklePtr)
+{
+  tricklePtr->ConsistentEvent ();
+  Simulator::Schedule (interval, &TrickleTimerTestCase::ConsistentEvent, this, interval, tricklePtr);
+}
+
+
+void
+TrickleTimerTestCase::DoRun (void)
+{
+  TestSteadyState (Time (1));
+  TestSteadyState (Seconds (1));
+  TestRedundancy (Seconds (1));
+}
+
+
+/**
+ * \ingroup timer-tests
+ *  Trickle Timer test suite
+ */
+class TrickleTimerTestSuite : public TestSuite
+{
+public:
+  /** Constructor. */
+  TrickleTimerTestSuite ()
+    : TestSuite ("trickle-timer")
+  {
+    AddTestCase (new TrickleTimerTestCase ());
+  }
+};
+
+/**
+ * \ingroup timer-tests
+ * TrickleTimerTestSuite instance variable.
+ */
+static TrickleTimerTestSuite g_trickleTimerTestSuite;
+
+
+}    // namespace tests
+
+}  // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/core/wscript ns-3.34/src/core/wscript
--- ns-3.33/src/core/wscript	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/core/wscript	2021-07-14 10:31:06.000000000 -0700
@@ -57,6 +57,8 @@
 
     conf.load('versioning', ['waf-tools'])
 
+    conf.require_boost_incs('core', 'ns-3 core module', required=False);
+
     int64x64_impl = Options.options.int64x64_impl
     if int64x64_impl == 'default' or int64x64_impl == 'int128':
 
@@ -166,28 +168,6 @@
     else:
         conf.env['ENABLE_BUILD_VERSION'] = False 
 
-    # Check for boost::units
-    if 'INCLUDES_BOOST' in conf.env:
-        fragment = r"""
-#include <boost/units/systems/si.hpp>
-int main ()
-{
-    auto q = 2 * boost::units::si::meter;
-    q.value ();
-}
-""" 
-        test_env = conf.env.derive()
-        test_env.append_value('INCLUDES', conf.env['INCLUDES_BOOST'])
-
-        ret = conf.check_nonfatal(compiler='cxx',
-                            define_name='HAVE_BOOST_UNITS',
-                            header_name='boost/units/systems/si.hpp',
-                            env=test_env,
-                            fragment=fragment,
-                            errmsg='not found')
-
-        conf.env.append_value ('CPPFLAGS', '-DHAVE_BOOST_UNITS')
-
     conf.write_config_header('ns3/core-config.h', top=True)
 
 def build(bld):
@@ -259,6 +239,7 @@
         'model/system-wall-clock-timestamp.cc',
         'helper/csv-reader.cc',
         'model/length.cc',
+        'model/trickle-timer.cc',
         ]
 
     if (bld.env['ENABLE_EXAMPLES']):
@@ -291,6 +272,7 @@
         'test/hash-test-suite.cc',
         'test/type-id-test-suite.cc',
         'test/length-test-suite.cc',
+        'test/trickle-timer-test-suite.cc',
         ]
 
     if (bld.env['ENABLE_EXAMPLES']):
@@ -394,7 +376,8 @@
         'model/time-printer.h',
         'model/show-progress.h',
         'helper/csv-reader.h',
-        'model/length.h'
+        'model/length.h',
+        'model/trickle-timer.h',
         ]
 
     if (bld.env['ENABLE_EXAMPLES']):
@@ -479,6 +462,9 @@
 
         headers.source.append('model/version.h')
 
+    if bld.env['INCLUDES_BOOST']:
+       core.use.append('BOOST')
+
     if Options.options.check_version:
         print_version(bld, vers_tg)
         raise SystemExit(0)
